﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using MGCPCBPartsEditor;
using Microsoft.VisualBasic;
using System.Diagnostics;
using Microsoft.Win32;


namespace VXLibrary_Test
{
	

public partial class Form1 : Form
    {
        
	public static string job;
	public static int com_version;
	public static string lib_path;

	public static string pdb_path;
	public static string path;
	public static string filename;
	public static string exe_path;
	public static string temp_path;
	public static int set_filename;
	public static bool use_list_file;
	public static Dictionary<long, string> dmatl = new Dictionary<long, string>();
	public static Dictionary<string, string> dlib = new Dictionary<string, string>();
	public static ArrayList list = new ArrayList();
	public static ArrayList pl = new ArrayList();


	public static MGCPCBPartsEditor.PartsEditorDlg part_ed_dlg;
	public static MGCPCBPartsEditor.PartsDB pdb_db;

	public static MGCPCBPartsEditor.Partitions partitions;
	public static MGCPCBPartsEditor.Partition partition;
	public static MGCPCBPartsEditor.Parts parts;
	public static MGCPCBPartsEditor.Part part;
	public static MGCPCBPartsEditor.CellReferences cellrefs;
	public static MGCPCBPartsEditor.CellReference cellref;
	public static MGCPCBPartsEditor.SymbolReferences symbs;
	public static MGCPCBPartsEditor.SymbolReference symb;
	public static MGCPCBPartsEditor.Properties props;
	public static MGCPCBPartsEditor.Property prop;

	public static CellEditorAddinLib.CellEditorDlg celldlg;
	public static CellEditorAddinLib.CellDB celldb;

	public static CellEditorAddinLib.Partitions clpartitions;
	public static CellEditorAddinLib.Partition clpartition;

	public static CellEditorAddinLib.Cells cells;
	public static CellEditorAddinLib.Cell cell;

	public static MGCPCB.CellEditorApplication cellapp;
	public static MGCPCB.Document celldoc;
	public static bool cellrunning;

	public static bool proceed;
	public static int prog_id;
	public static string mglaunch_path;
	
//DxDesigner Automation Globals
	public static ViewDraw.Application dxapp;
	public static object dxdoc;
	public static ViewDraw.IVdView view;
	public static ViewDraw.IProjectData prj;
	public static bool dxd_running;
	public static bool dxd_project_open;

//Expedition Automation Globals
	public static MGCPCB.ExpeditionPCBApplication pcbapp;
	public static MGCPCB.ViewerPCBApplication pcbviewapp;
	public static MGCPCB.Document pcbdoc;
	public static bool pcb_running;

//Drawing Editor Automation Globals
	public static MGCPCB.DrawingEditorApplication deapp;
	public static MGCPCB.Document dedoc;
	public static bool de_running;

	public static MGCPCB.FablinkXEApplication fabapp;
	public static MGCPCB.Document fabdoc;
	public static bool fab_running;
    	
    	
    	
    	
    public Form1()
        {
            InitializeComponent();
        }

        
	void Form1Load(object sender, EventArgs e)
        {
			int n = 0;
			
			job = "D:\\ENG\\LIBRARY\\RELEASED\\Mentor\\Central_Library_VXDx\\Central_Library.lmc";
			
			proceed = true;
			get_ver();
			get_mglaunch();
	
			
			
			Debug.Print(Constants.vbCrLf + "prog_id is: " + prog_id);
			Debug.Print(Constants.vbCrLf + "mglaunch_path is: " + Constants.vbCrLf + mglaunch_path + Constants.vbCrLf);
	
			
			if (proceed == false) {
				Interaction.MsgBox("Unable to find registry keys needed for automation access to EXpedition.");
				this.Close();
			}
	

			
			exe_path = Application.StartupPath.ToString() + "\\";
			
			Debug.Print("Form1Load");
			
	
        }
				
				
	private void button1_Click(object sender, EventArgs e)
		{
			try
			{
				Debug.Print("Getting Part Editor");
				//Get_Part_Editor();
				
				Debug.Print("Getting Part Info");
				//GetPartInfo();
				
				Debug.Print("Dropping Part Editor");
				//Drop_Part_Editor();
				
				Debug.Print("Getting CellEditor");
				GetCellEditor();
				
				Debug.Print("Getting CellLib");
				//GetCellLib();
				
				Debug.Print("Dropping CellLib");
				//DropCellLib();
				
				Debug.Print("Running DX_Connect");
				DX_Connect();
				
				Debug.Print("Running MGCPCB_Connect");
				MGCPCB_Connect();
				
				Debug.Print("Running MGC_Fab_Connect");
				MGC_Fab_Connect();
				
				Debug.Print("Running MGC_DE_Connect");
				MGC_DE_Connect();
				
				
				
				
				
					
				//Interaction.CreateObject("cellEditorAddin.cellEditorDlg");        //Cannot Create ActiveX component error
				//Interaction.CreateObject("MGCPCB.DrawingEditorApplication");      //Launched successfully
				//Interaction.CreateObject("ViewDraw.Application");                 //Launched successfully
				//Interaction.CreateObject("MGCPCB.ExpeditionPCBApplication");        //Launched successfully
				//Interaction.CreateObject("MGCPCB.FablinkXEApplication");            //Launched successfully
				//Interaction.CreateObject("LibraryManager.Application");             //Has launched successfully once, all other times it crashes after launching
				//Interaction.CreateObject("MGCPCBLibraries.PadstackEditorDlg");         //Cannot Create ActiveX component error
				
				//I use(d to use) this code just to verify a file the application was pointed to is a valid library file
				//PartsEditorDlg PedApp = (PartsEditorDlg)Interaction.CreateObject("MGCPCBLibraries.PartsEditorDlg");  //Cannot Create ActiveX component error
				//PartsEditorDlg PedApp = new PartsEditorDlg();  //Old way that was nice and easy to start a new COM instance.
				//PartsDB PedDoc = PedApp.OpenDatabaseEx(@"C:\Path\to\a\library.lmc", true);
				//PedApp.CloseActiveDatabase();
				//PedApp.Quit();
				//PedDoc = null;
				//PedApp = null;
			}
				catch (Exception exc)
			{
				MessageBox.Show(exc.ToString());
			}
		}
		
	public static void Get_Part_Editor()
	{
		//Creates a handle to the Parts Editor in Library Manager

		try 
		{
			part_ed_dlg = (PartsEditorDlg)Interaction.CreateObject("MGCPCBLibraries.PartsEditorDlg" + "." + prog_id.ToString());
		} catch (Exception ex) {
			Debug.Print("failing to create part editor session with this error: " + ex.Message);
			proceed = false;
			return;
		}
		
		
		Debug.Print("job is " + job);

		pdb_db = part_ed_dlg.OpenDatabaseEx(job, false);
		
		
		if (part_ed_dlg.LockServer()) {
			//do nothing
		} else {
			Interaction.MsgBox("Could not lock database for writing");
		}
	}


	public static void get_ver()
	{
		RegistryKey regkey = default(RegistryKey);
		string tmp = null;

		regkey = Registry.LocalMachine.OpenSubKey("SOFTWARE\\Classes\\MGCPCB.ExpeditionPCBApplication\\CurVer", false);

		if (regkey == null) {
			tmp = "Critical registry keys are missing.  This most likely means that the Mentor Graphics ";
			tmp = tmp + "tools have not been installed properly." + Constants.vbCrLf + Constants.vbCrLf;
			tmp = tmp + "Try to correct that then start over. ";
			Interaction.MsgBox(tmp);
			proceed = false;
			return;
		}
		
		
		tmp = (string) regkey.GetValue("");
		tmp = tmp.Substring(Strings.InStrRev(tmp, "."));
		prog_id = Convert.ToInt32(tmp);

		regkey.Close();
	}

	public static void get_mglaunch()
	{

		RegistryKey regkey = default(RegistryKey);
		string tmp = null;
		string[] keynames = null;
		string[] value_names = null;

		regkey = Registry.LocalMachine.OpenSubKey("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\mglaunch.exe", false);

		if (regkey == null) {
			tmp = "Critical registry keys are missing.  This most likely means that the Mentor Graphics ";
			tmp = tmp + "tools have not been installed properly." + Constants.vbCrLf + Constants.vbCrLf;
			tmp = tmp + "Try to correct that then start over. ";
			Interaction.MsgBox(tmp);
			proceed = false;
			return;
		}

		mglaunch_path = (string) regkey.GetValue("");
		regkey.Close();
	}

	public static void GetPartInfo()
	{
		//Iterates through each part in each partition and collects the needed info for oracle and DxDatabook
		//Get the collection of partitions in the parts editor
		partitions = pdb_db.Partitions;
		//Step through each partition in the parts editor
		foreach (MGCPCBPartsEditor.Partition _partition in partitions) {
			partition = _partition;
			//Get the collection of parts in the current partition
			parts = partition.Parts;
			//Step through each part in the parts collection
			foreach (MGCPCBPartsEditor.Part _part in parts) {
				part = _part;
				//Collect part information here
				//Get the collection of cells for the current part
				cellrefs = part.CellReferences;
				//Step through each cell in the cells collection
				foreach (MGCPCBPartsEditor.CellReference _cellRef in cellrefs) {
					cellref = _cellRef;
					//Collect cell information here
				}
				//Get the collection of symbols for the current part
				symbs = part.SymbolReferences;
				//Step through each symbol in the symbols collection
				foreach (MGCPCBPartsEditor.SymbolReference _symb in symbs) {
					symb = _symb;
					//Collect symbol information here
				}
				//Get the collection of properties on the current part
				props = part.Properties;
				//Step through each property in the properties collection
				foreach (MGCPCBPartsEditor.Property _prop in props) {
					prop = _prop;
					//Collect properties information here
				}
				//Do something with the data collected here
			}
		}
	}

	public static void Drop_Part_Editor()
	{
		//Close the open library and release hooks 

		//part_ed_dlg.SaveActiveDatabase
		part_ed_dlg.UnlockServer();
		part_ed_dlg.CloseActiveDatabase();
		pdb_db = null;
		part_ed_dlg = null;
	}



	public static void GetCellLib()
	{
		int n = 0;

		for (n = 1; n <= 5; n++) {
			DropCellLib();
		}

		celldb = null;
		celldlg = null;
		clpartitions = null;
		clpartition = null;
		cells = null;
		cell = null;

		try {
			celldlg =  (CellEditorAddinLib.CellEditorDlg) Interaction.CreateObject("CellEditorAddin.CellEditorDlg" + "." + prog_id.ToString());
		} catch (Exception ex) {
			Debug.Print("failing to create cell editor session with this error: " + ex.Message);
			proceed = false;
			return;
		}

		//there are some externally declared variables in here. 

		celldb = celldlg.OpenDatabase(job, false);
		celldlg.Visible = false;

	}

	public static void DropCellLib()
	{
		celldb = null;
		celldlg = null;
		clpartitions = null;
		clpartition = null;
		cells = null;
		cell = null;

		//msgbox("the Cell Library has been dropped")
	}

	public static void GetCellEditor()
	{

		short retVal = 0;


		cellapp = (MGCPCB.CellEditorApplication) Interaction.CreateObject("MGCPCB.CellEditorApplication" + "." + prog_id.ToString());

		celldoc = cellapp.ActiveDocument;

		if ((celldoc != null)) {
			cellrunning = true;
		}

		retVal = licenseDoc(ref celldoc);
		if (!(retVal == 1)) {
			celldoc = null;
			Interaction.MsgBox("There is no cell document running");
			return;
		}

		//cellapp.Visible = True

		return;
	}

	public static void DropCellEditor()
	{

		 // ERROR: Not supported in C#: OnErrorStatement


		while ((celldoc != null)) {
			celldoc.Close(false);
			celldoc = null;
		}


		//celldoc.Close(true)
		//celldoc = Nothing				
		cellapp.Quit();
		cellapp = null;


	}

	public static short licenseDoc(ref MGCPCB.Document docObj)
	{
		short functionReturnValue = 0;
		// =======================================================================
		// Retrieve a licence for the document
		// =======================================================================
		 // ERROR: Not supported in C#: OnErrorStatement

		short retState = 0;
		
		MGCPCBAutomationLicensing.Application licenseServer = null;
		//object licenseServer = null;
		int key = 0;
		int licenseToken = 0;
		string outErrMess = null;

		if ((docObj == null))
			goto end_of_function;

		// Ask the document for a key
		key = docObj.Validate(0);

		// Get license server
		 // ERROR: Not supported in C#: OnErrorStatement
		
		 licenseServer = (MGCPCBAutomationLicensing.Application) Interaction.CreateObject("MGCPCBAutomationLicensing.Application");
		if ((licenseServer == null))
			goto err_create_serverobj;
		 // ERROR: Not supported in C#: OnErrorStatement



		// Ask the license server for the license token
		licenseToken = licenseServer.GetToken(key);


		// Validate the document with the license token
		 // ERROR: Not supported in C#: OnErrorStatement

		int lRetval = 0;
		lRetval = docObj.Validate(licenseToken);

		 // ERROR: Not supported in C#: OnErrorStatement


		retState = 1;
		end_of_function:

		// release licence server
		licenseServer = null;
		functionReturnValue = retState;
		return functionReturnValue;
		show_error:


		MessageBox.Show( "Retrieving license for document");
		goto end_of_function;
		exit_with_error:

		outErrMess = "** Error ** " + Conversion.ErrorToString();
		retState = -1;
		goto show_error;
		err_create_serverobj:

		outErrMess = "** Error ** Could not create license server object";
		retState = -2;
		goto show_error;
		err_validate:

		outErrMess = "** Error ** Failed to validate document object";
		outErrMess = outErrMess + Constants.vbCrLf + "    License token : " + Strings.Trim(Conversion.Str(licenseToken));
		outErrMess = outErrMess + Constants.vbCrLf + "    Document key  : " + Strings.Trim(Conversion.Str(key));
		retState = -3;
		goto show_error;
		return functionReturnValue;

	}

	
	public static void DX_Connect()
	{
		Debug.Print("In DX_Connect");

		dxd_running = false;
		dxapp = null;


		dxapp = (ViewDraw.Application) Interaction.GetObject(null, "ViewDraw.Application" + "." + prog_id.ToString());
		dxd_running = true;

		prj = dxapp.GetProjectData();

		Debug.Print("project path is " + prj.GetProjectPath().ToString());

	}

	public static void MGCPCB_Connect()
	{
		// connects to MGCPCB
		short retVal = 0;
		bool proceed_expedition = false;
		bool proceed_viewer = false;

		pcb_running = false;
		proceed_expedition = true;
		proceed_viewer = true;

		try {
			pcbapp = (MGCPCB.ExpeditionPCBApplication) Interaction.GetObject(null, "MGCPCB.ExpeditionPCBApplication" + "." + prog_id.ToString());
		} catch (Exception ex) {
			proceed_expedition = false;
		}

		if (proceed_expedition == false) {
			try {
				pcbviewapp = (MGCPCB.ViewerPCBApplication) Interaction.GetObject(null, "MGCPCB.ViewerPCBApplication" + "." + prog_id.ToString());
			} catch (Exception ex) {
				proceed_viewer = false;
			}
		}

		if (proceed_expedition == false & proceed_viewer == false) {
			pcb_running = false;
			return;
		}

		pcbdoc = pcbapp.ActiveDocument;
		if ((pcbdoc != null)) {
			pcb_running = true;
		}

		// make sure the doc is licensed
		retVal = licenseDoc(ref pcbdoc);

		if ((retVal != 1)) {
			pcbdoc = null;
			pcb_running = false;
		}
		
		Debug.Print("pcbdoc.fullname is " + pcbdoc.FullName);

	}

	public static void MGCPCB_Disconnect()
	{
		// disconnects from MGCPCB.
		pcbdoc = null;
		pcbapp = null;
		// Disconnect from MGCPCB server
	}

	public static void MGC_DE_Connect()
	{
		// connects to MGCPCB
		short retVal = 0;

		de_running = false;
		 // ERROR: Not supported in C#: OnErrorStatement

		 deapp = (MGCPCB.DrawingEditorApplication) Interaction.GetObject(null, "MGCPCB.DrawingEditorApplication" + "." + prog_id.ToString());
		dedoc = deapp.ActiveDocument;

		if ((dedoc != null)) {
			de_running = true;
		}

		// make sure the doc is licensed
		retVal = licenseDoc(ref dedoc);

		if ((retVal != 1)) {
			dedoc = null;
			//de_running = false
		}
		
		Debug.Print("dedoc.fullname is " + dedoc.FullName);
		
		return;
	}

	public static void MGC_Fab_Connect()
	{
		// connects to MGCPCB
		short retVal = 0;

		fab_running = false;
		 // ERROR: Not supported in C#: OnErrorStatement

		 fabapp = (MGCPCB.FablinkXEApplication) Interaction.GetObject(null, "MGCPCB.FablinkXEApplication" + "." + prog_id.ToString());
		fabdoc = fabapp.ActiveDocument;



		// make sure the doc is licensed
		retVal = licenseDoc(ref fabdoc);

		if ((retVal != 1)) {
			fabdoc = null;
			//fab_running = false
		}

		if ((fabdoc != null)) {
			fab_running = true;
		}
		
		Debug.Print("fabdoc.fullname is " + fabdoc.FullName);

		return;
    }
	
	}


}
    
